function [] = selectOffsetsAndDrift()
%SELECTOFFSETSANDDRIFT Summary of this function goes here
%   Detailed explanation goes here

global artoaWorkspace;

%% Initialize required variables
selectedOffsets = table();

%% Get required variables
offsetsTable = artoaWorkspace.editOffsets.soundsourceOffsets;

%% Select float offset and drift
if artoaWorkspace.editOffsets.forceOptimumOffsets
    tmp = table();
    tmp.offset = offsetsTable{'Float', 'OptimumTotalOffset'};
    tmp.drift = offsetsTable{'Float', 'OptimumTotalDrift'};
    selectedOffsets('Float', :) = tmp;
    clear tmp;
else
    selectedOffsets('Float', :) = selectFromRow(offsetsTable('Float', :));
end

%% Run through all soundsources
variableNames = offsetsTable.Properties.RowNames;
for i = 1:length(variableNames)
    if strcmp('Float', variableNames{i})
        continue;
    end
    if artoaWorkspace.editOffsets.forceOptimumOffsets
        tmp = table();
        tmp.offset = offsetsTable{variableNames{i}, 'OptimumTotalOffset'};
        tmp.drift = offsetsTable{variableNames{i}, 'OptimumTotalDrift'};
        selectedOffsets(variableNames{i}, :) = tmp;
        clear tmp;
    else
        selectedOffsets(variableNames{i}, :) = selectFromRow(offsetsTable(variableNames{i}, :));
    end
end

%% Store selected values
artoaWorkspace.editOffsets.selectedOffsets = selectedOffsets;

    function [selected] = selectFromRow(pTableRow)
        % offset
        offset = 0;
        if ~isnan(pTableRow.EmpiricalOffset)
            offset = pTableRow.EmpiricalOffset;
        elseif ~isnan(pTableRow.OffsetStart)
            offset = pTableRow.OffsetStart;
        elseif ~isnan(pTableRow.OptimumTotalOffset)
            offset = pTableRow.OptimumTotalOffset;
        end
        % drift
        drift = 0;
        if ~isnan(pTableRow.EmpiricalDrift)
            drift = pTableRow.EmpiricalDrift;
        elseif ~isnan(pTableRow.Drift)
            drift = pTableRow.Drift;
        elseif ~isnan(pTableRow.OptimumTotalDrift)
            drift = pTableRow.OptimumTotalDrift;
        end
        selected = table();
        selected.offset = offset;
        selected.drift = drift;
    end

end

